//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unewtoniano.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include <alloc.h>
#include <math.hpp>
TForm1 *Form1;

//****************************************
double funcion1(double x)
   {
      return 1-exp(-param1*x*x);
   }

double dfuncion1(double x)
   {
      return 2*param1*x*exp(-param1*x*x);
   }
//****************************************
double funcion2(double x)
   {
      return 1.0-1.0/(1.0+param1*x*x);
   }

double dfuncion2(double x)
   {
      double aux=1+param1*x*x;
      return (2*param1*x)/(aux*aux);
   }
//****************************************
double funcion3(double x)
   {
      return fabs(x)<param2?param1*x*x:param1*param2*param2;
   }

double dfuncion3(double x)
   {
      return fabs(x)<param2?2*param1*x:0;
   }
//****************************************
double funcion4(double x)
   {
      return fabs(x);
   }

double dfuncion4(double x)
   {
      return x<0?-1:1;
   }
//****************************************
double funcion5(double x)
   {
      return x*x;
   }

double dfuncion5(double x)
   {
      return 2*x;
   }
//****************************************

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{


   imagen=NULL;
   resultado=NULL;
   observaciones=NULL;
   V=new Cventana(Image2, -2,2,-2,2);

   potencial[0]=funcion1;
   potencial[1]=dfuncion1;
   potencial[2]=funcion2;
   potencial[3]=dfuncion2;
   potencial[4]=funcion3;
   potencial[5]=dfuncion3;
   potencial[6]=funcion4;
   potencial[7]=dfuncion4;
   potencial[8]=funcion5;
   potencial[9]=dfuncion5;

}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
   if(imagen!=NULL)
      delete imagen;
   if(!OpenDialog1->Execute())
      return;
   imagen = new CimagenBN();
   imagen->I=Image1;
   imagen->cargarImagen(OpenDialog1->FileName);
   //imagen->normalizar();
   imagen->mostrarImagen();
   StatusBar1->SimpleText=AnsiString(imagen->maximo()-imagen->minimo());

}
//---------------------------------------------------------------------------
int numNodo(int f, int c, int N)
   {
     return f*N+c;
   }

int numFil(int nodo, int N)
   {
      return nodo/N;
   }

int numCol(int nodo, int N)
   {
      return nodo%N;
   }

int vecino(int k, int nodo,  int N)
   {
      switch(k)
         {
            case 0://arriba
               if(nodo>=N)
                  return nodo-N;
               else
                  return -1;
            case 1://izquierda
               if(nodo%N>0)
                  return nodo-1;
               else
                  return -1;
            case 2://abajo
               if(nodo<N*(N-1))
                  return nodo+N;
               else
                  return -1;
            case 3://derecha
               if(nodo%N<(N-1))
                  return nodo+1;
               else
                  return -1;
         }
      return -1;
   }

int numVecinos(int f, int c, int N)
   {
      int suma=2;
      if(f>0 && f<(N-1))
         suma++;
      if(c>0 && c<(N-1))
         suma++;
      return suma;
   }

double sumaVecinos(int f, int c, CimagenBN *A)
   {
      double suma=0;
      if(f>0)
         suma+=A->canal[f-1][c];
      if(f<(A->alto-1))
         suma+=A->canal[f+1][c];
      if(c>0)
         suma+=A->canal[f][c-1];
      if(c<(A->largo-1))
         suma+=A->canal[f][c+1];
      return suma;
   }

double sumaPotencialVecinos(int f, int c, CimagenBN *A, double (*potencial)(double))
   {
      double suma=0;
      if(f>0)
         suma+=potencial(A->canal[f][c]-A->canal[f-1][c]);
      if(f<(A->alto-1))
         suma+=potencial(A->canal[f][c]-A->canal[f+1][c]);
      if(c>0)
         suma+=potencial(A->canal[f][c]-A->canal[f][c-1]);
      if(c<(A->largo-1))
         suma+=potencial(A->canal[f][c]-A->canal[f][c+1]);
      return suma;
   }


void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
   int choice=RadioGroup2->ItemIndex;

   param1=Edit1->Text.ToDouble();
   param2=Edit2->Text.ToDouble();
   V->limpiar();
   V->dibujarEjes();
   V->graficarFuncion(potencial[2*RadioGroup1->ItemIndex+choice],V->minX, V->maxX);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
   if (observaciones!=NULL)
      delete observaciones;
   observaciones=new CimagenBN(imagen->largo, imagen->alto);
   double sigma=Edit3->Text.ToDouble();
   if(sigma==0)
      (*observaciones)=(*imagen);
   else
      (*observaciones)=imagen->conRuidoG(0,sigma);
   observaciones->I=Image3;
   observaciones->mostrarImagen();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
   if (observaciones==NULL)
      return;
   if(resultado!=NULL)
      delete resultado;

   double lambda=Edit10->Text.ToDouble();
   double k=Edit6->Text.ToDouble();
   double h=Edit5->Text.ToDouble();
   double cota=Edit4->Text.ToDouble();
   int maxIter=Edit7->Text.ToInt();
   int iter=0;
   double error, A, B, C;
   A=2.0/(k*h+1);
   B=(k*h-1.0)/(k*h+1);
   C=(h*h)/(k*h+1);

   param1=Edit1->Text.ToDouble();
   param2=Edit2->Text.ToDouble();

   CimagenBN *f1=new CimagenBN(observaciones->largo, observaciones->alto);
   CimagenBN *f2=new CimagenBN(observaciones->largo, observaciones->alto);
   CimagenBN *f3=new CimagenBN(observaciones->largo, observaciones->alto);
   CimagenBN *gradiente=new CimagenBN(observaciones->largo, observaciones->alto);
   CimagenBN *temp;

   f1->I=Image4;
   f2->I=Image4;
   f3->I=Image4;

   (*f1)=(*observaciones);
   (*f2)=(*observaciones);
   do
      {
         (*gradiente)=f2->gradientePlacas(observaciones,lambda);
         (*f3) =((*f2)*A);
         (*f3)+=((*f1)*B);
         (*f3)-=((*gradiente)*C);
         error=gradiente->magnitud();
         iter++;
         StatusBar1->SimpleText=(AnsiString(iter)+".")+error;
         if(!(iter%50))
            {
               f3->mostrarImagen();
               Application->ProcessMessages();
            }
         temp=f1;
         f1=f2;
         f2=f3;
         f3=temp;
      }
   while(error>cota && iter<maxIter);
   delete gradiente;
   delete f1;
   delete f2;
   delete f3;

}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{
   Image1->Picture->SaveToFile(Edit8->Text+".bmp");
   
   Image3->Picture->SaveToFile(Edit9->Text+".bmp");
   Image4->Picture->SaveToFile(Edit11->Text+".bmp");
}
//---------------------------------------------------------------------------



void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
   if (observaciones!=NULL)
      delete observaciones;
   observaciones=new CimagenBN(imagen->largo, imagen->alto);
   observaciones->ceros();
   for(int i=0;i<imagen->alto;i++)
      for (int j=0;j<imagen->largo;j++)
         {
            observaciones->canal[i][j]=imagen->canal[i][j]+RandG(0,1)/1000.0;
         }
   observaciones->I=Image3;
   observaciones->mostrarImagen();
}
//---------------------------------------------------------------------------



